open Types
open Atom
open Typerr

let deconstruct_arrow p loc : ftype -> ftype * ftype =
  function
    | TyArrow (domain, codomain) ->
	domain, codomain
    | ty ->
	expected_form p loc "an arrow" ty

let deconstruct_quantifier q p loc ty = 
  match ty with 
    | TyQuantified (q', body) when q' = q -> body
    | ty ->
        let expected =
          match q with
          | QForall -> "a universal"
          | QExists -> "an existential" in
        expected_form p loc expected ty

let deconstruct_record p loc : ftype -> ftype AtomMap.t  =
  function
    | TyRecord fields -> fields
    | ty ->
	expected_form p loc "a record" ty

let deconstruct_record_label p loc label ty : ftype =
  let fields = deconstruct_record p loc ty in
  try AtomMap.find label fields
  with Not_found ->
    expected_field p loc label ty


let matching p loc ct ty2 =
  match matching ct ty2 with
  | Some (Some ty0) -> ty0
  | Some (None) -> TyRecord AtomMap.empty (* any type *)
  | None ->
     mismatch_coercion p loc ct ty2
      
